module Queue (Queue, empty, insert, deleteMin) where
import Prelude (Ord, Show, Maybe, (<=), return)
import Control.Monad (mzero)
 
data Queue k v = E
               | T !k !v !(QueueList k v)
               deriving Show
 
data QueueList k v = N
                   | C !(Queue k v) !(QueueList k v)
                   deriving Show
 
empty :: Queue k v
empty = E
 
merge :: (Ord k) => Queue k v -> Queue k v -> Queue k v
merge (E) q2 = q2
merge q1 (E) = q1
merge q1@(T k1 v1 q1's) q2@(T k2 v2 q2's)
  = if k1 <= k2 then T k1 v1 (C q2 q1's) else T k2 v2 (C q1 q2's)
 
insert :: (Ord k) => k -> v -> Queue k v -> Queue k v
insert k v = merge (T k v N)
 
mergePairs :: (Ord k) => QueueList k v -> Queue k v
mergePairs (N) = E
mergePairs (C q N) = q
mergePairs (C q1 (C q2 qs''))
  = merge (merge q1 q2) (mergePairs qs'')
 
deleteMin :: (Ord k) => Queue k v -> Maybe (v, Queue k v)
deleteMin (E) = mzero
deleteMin (T _k v q's) = return (v, mergePairs q's)
